import React from 'react';
import Instatype from 'instatype';
import Grid from 'react-simple-grid';
import Unsplash from 'unsplash-js';
import { throttle } from 'lodash';

const unsplash = new Unsplash({ applicationId: '806337d0390512806adf0ab960cb1fbc65b631dfe303a14dcb56432003bd8bfc' });

class App extends React.Component {

  constructor(props){
    super(props);

    this.state = {
      photos: null
    }

    this.requestHandlerThrottled = throttle(this.requestHandler.bind(this), 300);
    this.selectedHandler = this.selectedHandler.bind(this);
  }

  requestHandler(query, limit, callback){

    // Hard-coded until unsplash increase our rate limit
    const json = {"total":5,"total_pages":1,"results":[{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"followed_by_user":false,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"photos":[{"id":"j0g8taxHZa0","created_at":"2015-09-16T08:37:11-04:00","width":4342,"height":2895,"color":"#4B4B4B","likes":1664,"liked_by_user":false,"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1442406964439-e46ab8eff7c4","full":"https://images.unsplash.com/photo-1442406964439-e46ab8eff7c4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=74285702a4dee2862219fdea8cd2045d","regular":"https://images.unsplash.com/photo-1442406964439-e46ab8eff7c4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=efd0cad767236aae5bb586a8707e1bb9","small":"https://images.unsplash.com/photo-1442406964439-e46ab8eff7c4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=1b8c67f61ce3c4fb38a884d5aae80ea0","thumb":"https://images.unsplash.com/photo-1442406964439-e46ab8eff7c4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=89498bd1f283e9538ddc9a4af4349e7b"},"categories":[{"id":2,"title":"Buildings","photo_count":22897,"links":{"self":"https://api.unsplash.com/categories/2","photos":"https://api.unsplash.com/categories/2/photos"}}],"links":{"self":"https://api.unsplash.com/photos/j0g8taxHZa0","html":"http://unsplash.com/photos/j0g8taxHZa0","download":"http://unsplash.com/photos/j0g8taxHZa0/download","download_location":"https://api.unsplash.com/photos/j0g8taxHZa0/download"}},{"id":"YN_JWPDYVoM","created_at":"2014-12-10T10:24:36-05:00","width":4896,"height":3264,"color":"#414B4B","likes":444,"liked_by_user":false,"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1418225043143-90858d2301b4","full":"https://images.unsplash.com/photo-1418225043143-90858d2301b4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=658de8656e7e13ea5ad7a8717f5798b5","regular":"https://images.unsplash.com/photo-1418225043143-90858d2301b4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=a653e62f43c02b6aed9c5cc94f10c472","small":"https://images.unsplash.com/photo-1418225043143-90858d2301b4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=332db30170e57c1491028094fd5624cd","thumb":"https://images.unsplash.com/photo-1418225043143-90858d2301b4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=52e7a50b34fdfa519d46660b7e1e57e4"},"categories":[{"id":4,"title":"Nature","photo_count":54184,"links":{"self":"https://api.unsplash.com/categories/4","photos":"https://api.unsplash.com/categories/4/photos"}},{"id":6,"title":"People","photo_count":18319,"links":{"self":"https://api.unsplash.com/categories/6","photos":"https://api.unsplash.com/categories/6/photos"}}],"links":{"self":"https://api.unsplash.com/photos/YN_JWPDYVoM","html":"http://unsplash.com/photos/YN_JWPDYVoM","download":"http://unsplash.com/photos/YN_JWPDYVoM/download","download_location":"https://api.unsplash.com/photos/YN_JWPDYVoM/download"}},{"id":"UyUvM0xcqMA","created_at":"2014-10-12T18:28:32-04:00","width":4237,"height":2814,"color":"#5E5E5E","likes":456,"liked_by_user":false,"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/uploads/14131528928453585b6dc/829d24cf","full":"https://images.unsplash.com/uploads/14131528928453585b6dc/829d24cf?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=851ed16fd973c0a946045b43cf5c49f7","regular":"https://images.unsplash.com/uploads/14131528928453585b6dc/829d24cf?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=a3ad2eee0ad6e07d7e694d7af3c69c82","small":"https://images.unsplash.com/uploads/14131528928453585b6dc/829d24cf?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=0d75fb535e4517162ce8de7113785b38","thumb":"https://images.unsplash.com/uploads/14131528928453585b6dc/829d24cf?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=a0ded1633038b7ae15e9d69e3b84619b"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/UyUvM0xcqMA","html":"http://unsplash.com/photos/UyUvM0xcqMA","download":"http://unsplash.com/photos/UyUvM0xcqMA/download","download_location":"https://api.unsplash.com/photos/UyUvM0xcqMA/download"}}],"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},{"id":"Q4NfGpMNvzs","username":"samdasherx13","name":"Samuel Myles","first_name":"Samuel","last_name":"Myles","portfolio_url":"http://samdasherx13.tumblr.com/","bio":"","location":"Wichita, Kansas","total_likes":166,"total_photos":11,"total_collections":0,"followed_by_user":false,"profile_image":{"small":"https://images.unsplash.com/profile-1450245839093-95fa430f70d0?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=c8a9b78219de3f76770bc5de371b3af9","medium":"https://images.unsplash.com/profile-1450245839093-95fa430f70d0?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=e51f87c95c5f7d0493a5327923b2a584","large":"https://images.unsplash.com/profile-1450245839093-95fa430f70d0?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=caf9d96cbb762aefca4917120549ec4e"},"photos":[{"id":"CdX0FV_hIVA","created_at":"2016-05-18T12:56:02-04:00","width":6000,"height":4000,"color":"#F2ECCE","likes":33,"liked_by_user":false,"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1463590469467-c60accd525f3","full":"https://images.unsplash.com/photo-1463590469467-c60accd525f3?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=f357fe042e3b419b7626bd039262991f","regular":"https://images.unsplash.com/photo-1463590469467-c60accd525f3?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=3717a16416f43bdd16dbf2c6e098c55c","small":"https://images.unsplash.com/photo-1463590469467-c60accd525f3?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=4bc80283cb275c0b3b4e173d9f0a9dbf","thumb":"https://images.unsplash.com/photo-1463590469467-c60accd525f3?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=f2b5335b6561a9f15dc73fabd61b8d85"},"categories":[{"id":4,"title":"Nature","photo_count":54184,"links":{"self":"https://api.unsplash.com/categories/4","photos":"https://api.unsplash.com/categories/4/photos"}}],"links":{"self":"https://api.unsplash.com/photos/CdX0FV_hIVA","html":"http://unsplash.com/photos/CdX0FV_hIVA","download":"http://unsplash.com/photos/CdX0FV_hIVA/download","download_location":"https://api.unsplash.com/photos/CdX0FV_hIVA/download"}},{"id":"yiJyG4oKNJE","created_at":"2016-06-28T17:32:43-04:00","width":5292,"height":3506,"color":"#FFFFFF","likes":1,"liked_by_user":false,"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1467149493705-a2e44ea86609","full":"https://images.unsplash.com/photo-1467149493705-a2e44ea86609?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=11c07f9e1c2bbdc9ff797d6dc73fdb4a","regular":"https://images.unsplash.com/photo-1467149493705-a2e44ea86609?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=8322e017c772dcf1740adba665927bd3","small":"https://images.unsplash.com/photo-1467149493705-a2e44ea86609?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=7af2fbab235c02b702cbfa6a4df84e92","thumb":"https://images.unsplash.com/photo-1467149493705-a2e44ea86609?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=1e8cd6d937fa62ab8728873297187f05"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/yiJyG4oKNJE","html":"http://unsplash.com/photos/yiJyG4oKNJE","download":"http://unsplash.com/photos/yiJyG4oKNJE/download","download_location":"https://api.unsplash.com/photos/yiJyG4oKNJE/download"}},{"id":"tSH_HLE4lBM","created_at":"2015-12-16T01:19:59-05:00","width":6000,"height":4000,"color":"#FEFEFC","likes":1,"liked_by_user":false,"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1450246630295-47deda7b0329","full":"https://images.unsplash.com/photo-1450246630295-47deda7b0329?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=69271f09ba6bf65fd721c00b68d4e1e9","regular":"https://images.unsplash.com/photo-1450246630295-47deda7b0329?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=1be786f966ea9123dad89671b6edfa47","small":"https://images.unsplash.com/photo-1450246630295-47deda7b0329?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=ad24cd5242e22d2d49f85474c2645334","thumb":"https://images.unsplash.com/photo-1450246630295-47deda7b0329?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=50e50a06d83f1317a09fda462eff9903"},"categories":[{"id":2,"title":"Buildings","photo_count":22897,"links":{"self":"https://api.unsplash.com/categories/2","photos":"https://api.unsplash.com/categories/2/photos"}}],"links":{"self":"https://api.unsplash.com/photos/tSH_HLE4lBM","html":"http://unsplash.com/photos/tSH_HLE4lBM","download":"http://unsplash.com/photos/tSH_HLE4lBM/download","download_location":"https://api.unsplash.com/photos/tSH_HLE4lBM/download"}}],"links":{"self":"https://api.unsplash.com/users/samdasherx13","html":"http://unsplash.com/@samdasherx13","photos":"https://api.unsplash.com/users/samdasherx13/photos","likes":"https://api.unsplash.com/users/samdasherx13/likes","portfolio":"https://api.unsplash.com/users/samdasherx13/portfolio","following":"https://api.unsplash.com/users/samdasherx13/following","followers":"https://api.unsplash.com/users/samdasherx13/followers"}},{"id":"JyF-vO22kiA","username":"samuelmelk","name":"Samuel Melchioretto","first_name":"Samuel","last_name":"Melchioretto","portfolio_url":null,"bio":"","location":null,"total_likes":0,"total_photos":0,"total_collections":0,"followed_by_user":false,"profile_image":{"small":"https://images.unsplash.com/profile-fb-1478352903-65e431199f43.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=3e267280b4a02d1ab0bb93f0dbf6b3c6","medium":"https://images.unsplash.com/profile-fb-1478352903-65e431199f43.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=e4b02ec940fadde06e5d90e739b5543d","large":"https://images.unsplash.com/profile-fb-1478352903-65e431199f43.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=3d52bcc6a4fa9e3679fc1989e2981a9d"},"photos":[],"links":{"self":"https://api.unsplash.com/users/samuelmelk","html":"http://unsplash.com/@samuelmelk","photos":"https://api.unsplash.com/users/samuelmelk/photos","likes":"https://api.unsplash.com/users/samuelmelk/likes","portfolio":"https://api.unsplash.com/users/samuelmelk/portfolio","following":"https://api.unsplash.com/users/samuelmelk/following","followers":"https://api.unsplash.com/users/samuelmelk/followers"}},{"id":"Cc_KHNnaQNU","username":"samuel_clement","name":"Samuel Clement","first_name":"Samuel","last_name":"Clement","portfolio_url":null,"bio":"","location":null,"total_likes":0,"total_photos":0,"total_collections":0,"followed_by_user":false,"profile_image":{"small":"https://images.unsplash.com/placeholder-avatars/extra-large.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=0ad68f44c4725d5a3fda019bab9d3edc","medium":"https://images.unsplash.com/placeholder-avatars/extra-large.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=356bd4b76a3d4eb97d63f45b818dd358","large":"https://images.unsplash.com/placeholder-avatars/extra-large.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=ee8bbf5fb8d6e43aaaa238feae2fe90d"},"photos":[],"links":{"self":"https://api.unsplash.com/users/samuel_clement","html":"http://unsplash.com/@samuel_clement","photos":"https://api.unsplash.com/users/samuel_clement/photos","likes":"https://api.unsplash.com/users/samuel_clement/likes","portfolio":"https://api.unsplash.com/users/samuel_clement/portfolio","following":"https://api.unsplash.com/users/samuel_clement/following","followers":"https://api.unsplash.com/users/samuel_clement/followers"}},{"id":"x0c8f95Htmo","username":"samuelmills","name":"samuel mills","first_name":"samuel","last_name":"mills","portfolio_url":null,"bio":"","location":null,"total_likes":0,"total_photos":0,"total_collections":0,"followed_by_user":false,"profile_image":{"small":"https://images.unsplash.com/placeholder-avatars/extra-large.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=0ad68f44c4725d5a3fda019bab9d3edc","medium":"https://images.unsplash.com/placeholder-avatars/extra-large.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=356bd4b76a3d4eb97d63f45b818dd358","large":"https://images.unsplash.com/placeholder-avatars/extra-large.jpg?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=ee8bbf5fb8d6e43aaaa238feae2fe90d"},"photos":[],"links":{"self":"https://api.unsplash.com/users/samuelmills","html":"http://unsplash.com/@samuelmills","photos":"https://api.unsplash.com/users/samuelmills/photos","likes":"https://api.unsplash.com/users/samuelmills/likes","portfolio":"https://api.unsplash.com/users/samuelmills/portfolio","following":"https://api.unsplash.com/users/samuelmills/following","followers":"https://api.unsplash.com/users/samuelmills/followers"}}]}

    //unsplash.search.users(query, 1)
    //.then(response => response.json())
    //.then(json => {

      // Set "image" and "name" properties
      const data = json.results.map((user) => {
        user.image = user.profile_image.medium;
        user.name = user.name;
        return user;
      });

      callback(data);

    //});
  }

  selectedHandler(result){

    //const json = [{"id":"9ZwwmGUHXbo","created_at":"2016-11-29T14:00:15-05:00","width":3264,"height":4896,"color":"#FEEEE8","likes":1,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1480445832621-23df89ee0fcc","full":"https://images.unsplash.com/photo-1480445832621-23df89ee0fcc?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=c45b75f518e8bf7171a81e90c5782b75","regular":"https://images.unsplash.com/photo-1480445832621-23df89ee0fcc?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=8ad187e9dce1b3348dcb3fb0befb2f2d","small":"https://images.unsplash.com/photo-1480445832621-23df89ee0fcc?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=8a342a954be209f33bc6b882ac83e099","thumb":"https://images.unsplash.com/photo-1480445832621-23df89ee0fcc?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=6f2d078c68d7c87e71b4781bc34a046f"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/9ZwwmGUHXbo","html":"http://unsplash.com/photos/9ZwwmGUHXbo","download":"http://unsplash.com/photos/9ZwwmGUHXbo/download","download_location":"https://api.unsplash.com/photos/9ZwwmGUHXbo/download"}},{"id":"yn_x_igbgPc","created_at":"2016-11-28T08:25:28-05:00","width":4896,"height":3264,"color":"#07090C","likes":122,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1480339066136-cbded9b457ab","full":"https://images.unsplash.com/photo-1480339066136-cbded9b457ab?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=65f5a54f33577a1479f3640feeb82db8","regular":"https://images.unsplash.com/photo-1480339066136-cbded9b457ab?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=d7452623b77cbe2ec4a0857512149f4f","small":"https://images.unsplash.com/photo-1480339066136-cbded9b457ab?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=21d0581ad138786c9899709319071682","thumb":"https://images.unsplash.com/photo-1480339066136-cbded9b457ab?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=f9eb2be1f208314961f6f6f51d02ed92"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/yn_x_igbgPc","html":"http://unsplash.com/photos/yn_x_igbgPc","download":"http://unsplash.com/photos/yn_x_igbgPc/download","download_location":"https://api.unsplash.com/photos/yn_x_igbgPc/download"}},{"id":"0jw6_7Hy-rM","created_at":"2016-11-28T06:57:51-05:00","width":6000,"height":4000,"color":"#F2E6D8","likes":85,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1480334026689-1ee5069c978f","full":"https://images.unsplash.com/photo-1480334026689-1ee5069c978f?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=a80bb4f83145ba1023483708699190f0","regular":"https://images.unsplash.com/photo-1480334026689-1ee5069c978f?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=0f690eb532bf2238adacc5bdfe714a30","small":"https://images.unsplash.com/photo-1480334026689-1ee5069c978f?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=fad9364f8e63fe088a8dc32d09a22294","thumb":"https://images.unsplash.com/photo-1480334026689-1ee5069c978f?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=0bf5366ca7ff0f575d98030d93269051"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/0jw6_7Hy-rM","html":"http://unsplash.com/photos/0jw6_7Hy-rM","download":"http://unsplash.com/photos/0jw6_7Hy-rM/download","download_location":"https://api.unsplash.com/photos/0jw6_7Hy-rM/download"}},{"id":"XOA4SIO6c3I","created_at":"2016-11-28T06:46:31-05:00","width":3156,"height":4734,"color":"#F7F7F7","likes":0,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1480333440693-6ef380b9d2f4","full":"https://images.unsplash.com/photo-1480333440693-6ef380b9d2f4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=dc4684e4484d36b85fcf9ed9d9d3f2e0","regular":"https://images.unsplash.com/photo-1480333440693-6ef380b9d2f4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=c24407d607d87125cfdf0ee68b40544b","small":"https://images.unsplash.com/photo-1480333440693-6ef380b9d2f4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=61e510ee5945593f1d5f50ef57c08fa7","thumb":"https://images.unsplash.com/photo-1480333440693-6ef380b9d2f4?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=01217453cbb9a0d83863086a59608b50"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/XOA4SIO6c3I","html":"http://unsplash.com/photos/XOA4SIO6c3I","download":"http://unsplash.com/photos/XOA4SIO6c3I/download","download_location":"https://api.unsplash.com/photos/XOA4SIO6c3I/download"}},{"id":"PdGlBdz8q8U","created_at":"2016-11-28T06:36:28-05:00","width":3161,"height":4742,"color":"#0C1113","likes":31,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1480332815230-946779a1f39b","full":"https://images.unsplash.com/photo-1480332815230-946779a1f39b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=7548d7f3adeee70bfbce8f07a2a8102d","regular":"https://images.unsplash.com/photo-1480332815230-946779a1f39b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=2195e3f8b91300464ed34952872ac2ee","small":"https://images.unsplash.com/photo-1480332815230-946779a1f39b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=79d7fd0d38b03167cf7fe68d60ad87be","thumb":"https://images.unsplash.com/photo-1480332815230-946779a1f39b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=979690b391d1f4d782b8cdea2de0a0e3"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/PdGlBdz8q8U","html":"http://unsplash.com/photos/PdGlBdz8q8U","download":"http://unsplash.com/photos/PdGlBdz8q8U/download","download_location":"https://api.unsplash.com/photos/PdGlBdz8q8U/download"}},{"id":"VK284NKoAVU","created_at":"2016-11-05T11:05:25-04:00","width":4000,"height":6000,"color":"#FFA08E","likes":108,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1478358161113-b0e11994a36b","full":"https://images.unsplash.com/photo-1478358161113-b0e11994a36b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=b0ad295fcf87d0143708edcf88e97162","regular":"https://images.unsplash.com/photo-1478358161113-b0e11994a36b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=545bb25856598ef66864e9b875a15581","small":"https://images.unsplash.com/photo-1478358161113-b0e11994a36b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=23108237289fc36c8bc1e2d2787b9e20","thumb":"https://images.unsplash.com/photo-1478358161113-b0e11994a36b?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=1247cc150620b4a4c9ab53bff6f58962"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/VK284NKoAVU","html":"http://unsplash.com/photos/VK284NKoAVU","download":"http://unsplash.com/photos/VK284NKoAVU/download","download_location":"https://api.unsplash.com/photos/VK284NKoAVU/download"}},{"id":"xZd3EUj9fFE","created_at":"2016-11-01T14:33:53-04:00","width":4860,"height":3240,"color":"#020202","likes":63,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1478025101087-7f1ce4c83156","full":"https://images.unsplash.com/photo-1478025101087-7f1ce4c83156?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=d77b8c201f4315222f4e0a04aa910af7","regular":"https://images.unsplash.com/photo-1478025101087-7f1ce4c83156?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=509fc91e8af585293578d2794bd8bbab","small":"https://images.unsplash.com/photo-1478025101087-7f1ce4c83156?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=86d76d2e146c4d9dc06e90848c0a4b49","thumb":"https://images.unsplash.com/photo-1478025101087-7f1ce4c83156?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=9132b98a6ea891090406b2fbd5b1a2fb"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/xZd3EUj9fFE","html":"http://unsplash.com/photos/xZd3EUj9fFE","download":"http://unsplash.com/photos/xZd3EUj9fFE/download","download_location":"https://api.unsplash.com/photos/xZd3EUj9fFE/download"}},{"id":"P0srUaN6CFI","created_at":"2016-11-01T14:25:51-04:00","width":6000,"height":4000,"color":"#3C2B2B","likes":74,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1478024646077-8a9b56e5319c","full":"https://images.unsplash.com/photo-1478024646077-8a9b56e5319c?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=0e5bf8e0ee6dae297572ee26807ed862","regular":"https://images.unsplash.com/photo-1478024646077-8a9b56e5319c?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=35da6bd699999dc24d0762183ea30e8b","small":"https://images.unsplash.com/photo-1478024646077-8a9b56e5319c?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=74116fa57462d0645d588010806801eb","thumb":"https://images.unsplash.com/photo-1478024646077-8a9b56e5319c?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=c94a92764b2b745aa6fb83b942fa26b4"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/P0srUaN6CFI","html":"http://unsplash.com/photos/P0srUaN6CFI","download":"http://unsplash.com/photos/P0srUaN6CFI/download","download_location":"https://api.unsplash.com/photos/P0srUaN6CFI/download"}},{"id":"CMIwnrT6ukM","created_at":"2016-11-01T14:21:08-04:00","width":4896,"height":3264,"color":"#070603","likes":36,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1478024386625-2c8f6e74c874","full":"https://images.unsplash.com/photo-1478024386625-2c8f6e74c874?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=194da7fa55298806b61b4c513f8c53c5","regular":"https://images.unsplash.com/photo-1478024386625-2c8f6e74c874?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=07d49b1c37316a9425ab7c7155ff5aff","small":"https://images.unsplash.com/photo-1478024386625-2c8f6e74c874?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=4b5bcf1b70b2bf7a1811241c23062251","thumb":"https://images.unsplash.com/photo-1478024386625-2c8f6e74c874?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=84fc9de56baad9852d01830dc5f8abe8"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/CMIwnrT6ukM","html":"http://unsplash.com/photos/CMIwnrT6ukM","download":"http://unsplash.com/photos/CMIwnrT6ukM/download","download_location":"https://api.unsplash.com/photos/CMIwnrT6ukM/download"}},{"id":"yWvfQwwtXhk","created_at":"2016-11-01T13:52:21-04:00","width":3066,"height":2300,"color":"#FCFCFC","likes":8,"liked_by_user":false,"user":{"id":"gnwb2chNB0Q","username":"samuelzeller","name":"Samuel Zeller","first_name":"Samuel","last_name":"Zeller","portfolio_url":"http://www.samuelzeller.ch/","bio":"Freelance photographer available for projects. On Instagram @zellersamuel - Inquiries: sam@samuelzeller.ch","location":"Geneva, Switzerland","total_likes":52,"total_photos":210,"total_collections":3,"profile_image":{"small":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=32\u0026w=32\u0026s=55a9d05123e81facff8540f8dd04f6ac","medium":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=64\u0026w=64\u0026s=b5b6563604a357c81ab7b7d031711621","large":"https://images.unsplash.com/profile-1459084990923-3f9f152c3799?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=faces\u0026cs=tinysrgb\u0026fit=crop\u0026h=128\u0026w=128\u0026s=f2d56cf35c7e667ca84ed0a4dabdc2c6"},"links":{"self":"https://api.unsplash.com/users/samuelzeller","html":"http://unsplash.com/@samuelzeller","photos":"https://api.unsplash.com/users/samuelzeller/photos","likes":"https://api.unsplash.com/users/samuelzeller/likes","portfolio":"https://api.unsplash.com/users/samuelzeller/portfolio","following":"https://api.unsplash.com/users/samuelzeller/following","followers":"https://api.unsplash.com/users/samuelzeller/followers"}},"current_user_collections":[],"urls":{"raw":"https://images.unsplash.com/photo-1478022599861-7d8a1d4745cd","full":"https://images.unsplash.com/photo-1478022599861-7d8a1d4745cd?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026s=d40975963eac4d400c4bb140f8002af8","regular":"https://images.unsplash.com/photo-1478022599861-7d8a1d4745cd?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=1080\u0026fit=max\u0026s=2fb9ba1b6cf079ba2921792a85cad9bd","small":"https://images.unsplash.com/photo-1478022599861-7d8a1d4745cd?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=400\u0026fit=max\u0026s=0c0ecfc6788f7761a327f628ddff7999","thumb":"https://images.unsplash.com/photo-1478022599861-7d8a1d4745cd?ixlib=rb-0.3.5\u0026q=80\u0026fm=jpg\u0026crop=entropy\u0026cs=tinysrgb\u0026w=200\u0026fit=max\u0026s=3dc5323994e77a2817222724b04ffe82"},"categories":[],"links":{"self":"https://api.unsplash.com/photos/yWvfQwwtXhk","html":"http://unsplash.com/photos/yWvfQwwtXhk","download":"http://unsplash.com/photos/yWvfQwwtXhk/download","download_location":"https://api.unsplash.com/photos/yWvfQwwtXhk/download"}}]

    unsplash.users.photos(result.username)
    .then(response => response.json())
    .then(json => {
        this.setState({
          photos: json
        })
    });
  }

  render(){

    const { photos } = this.state;

    return(
      <div>
        <div id="navbar">
          <Instatype 
            placeholder="Search Unsplash" 
            requestHandler={this.requestHandlerThrottled}
            selectedHandler={this.selectedHandler}
            limit={10} 
            thumbStyle="circle"/>
        </div>

        { photos && photos.length > 0 && 
          <div style={{ overflowX: 'hidden' }}>
            <Grid blocksPerRow={4} blockSpacing={4} hideOuterSpacing={true}>
              {photos.map(photo => (     
                <a href={photo.links.html} target="_blank" key={photo.id} >
                  <img src={'https://source.unsplash.com/' + photo.id +'/400x400'} style={{ display: 'block', width: '100%' }}/> 
                </a>
              ))}
            </Grid>
          </div>
        }
      
        { photos && photos.length === 0 &&
          <div style={{ fontSize: '2em', textAlign: 'center', marginTop: '2em', color: '#6e6e6e' }}>
            This user has no photos :(
          </div>
        }
      </div>
    )
  }
};

export default App 
